/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumDatatype;
import de.ship.db.tables.records.VDataquierRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDataquier extends TableImpl<VDataquierRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dataquier</code>
     */
    public static final VDataquier V_DATAQUIER = new VDataquier();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDataquierRecord> getRecordType() {
        return VDataquierRecord.class;
    }

    /**
     * The column <code>common_dd.v_dataquier.var_names</code>.
     */
    public final TableField<VDataquierRecord, String> VAR_NAMES = createField(DSL.name("var_names"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.label</code>.
     */
    public final TableField<VDataquierRecord, String> LABEL = createField(DSL.name("label"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.long_label</code>.
     */
    public final TableField<VDataquierRecord, String> LONG_LABEL = createField(DSL.name("long_label"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.label_de</code>.
     */
    public final TableField<VDataquierRecord, String> LABEL_DE = createField(DSL.name("label_de"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.long_label_de</code>.
     */
    public final TableField<VDataquierRecord, String> LONG_LABEL_DE = createField(DSL.name("long_label_de"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.data_type</code>.
     */
    public final TableField<VDataquierRecord, EnumDatatype> DATA_TYPE = createField(DSL.name("data_type"), SQLDataType.VARCHAR.asEnumDataType(EnumDatatype.class), this, "");

    /**
     * The column <code>common_dd.v_dataquier.value_labels</code>.
     */
    public final TableField<VDataquierRecord, String> VALUE_LABELS = createField(DSL.name("value_labels"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.value_labels_de</code>.
     */
    public final TableField<VDataquierRecord, String> VALUE_LABELS_DE = createField(DSL.name("value_labels_de"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.missing_list</code>.
     */
    public final TableField<VDataquierRecord, String> MISSING_LIST = createField(DSL.name("missing_list"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.missing_list_de</code>.
     */
    public final TableField<VDataquierRecord, String> MISSING_LIST_DE = createField(DSL.name("missing_list_de"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.key_observer</code>.
     */
    public final TableField<VDataquierRecord, String> KEY_OBSERVER = createField(DSL.name("key_observer"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.key_datetime</code>.
     */
    public final TableField<VDataquierRecord, String> KEY_DATETIME = createField(DSL.name("key_datetime"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.key_device</code>.
     */
    public final TableField<VDataquierRecord, String> KEY_DEVICE = createField(DSL.name("key_device"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.key_study_segment</code>.
     */
    public final TableField<VDataquierRecord, String> KEY_STUDY_SEGMENT = createField(DSL.name("key_study_segment"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.variable_order</code>.
     */
    public final TableField<VDataquierRecord, Integer> VARIABLE_ORDER = createField(DSL.name("variable_order"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dataquier.short_name</code>.
     */
    public final TableField<VDataquierRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.stata_missing</code>.
     */
    public final TableField<VDataquierRecord, String> STATA_MISSING = createField(DSL.name("stata_missing"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.stata_dependency</code>.
     */
    public final TableField<VDataquierRecord, String> STATA_DEPENDENCY = createField(DSL.name("stata_dependency"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.stata_hard_limit</code>.
     */
    public final TableField<VDataquierRecord, String> STATA_HARD_LIMIT = createField(DSL.name("stata_hard_limit"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.stata_soft_limit</code>.
     */
    public final TableField<VDataquierRecord, String> STATA_SOFT_LIMIT = createField(DSL.name("stata_soft_limit"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.stata_key_observer</code>.
     */
    public final TableField<VDataquierRecord, String> STATA_KEY_OBSERVER = createField(DSL.name("stata_key_observer"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.stata_key_datetime</code>.
     */
    public final TableField<VDataquierRecord, String> STATA_KEY_DATETIME = createField(DSL.name("stata_key_datetime"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.stata_key_device</code>.
     */
    public final TableField<VDataquierRecord, String> STATA_KEY_DEVICE = createField(DSL.name("stata_key_device"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.hard_limits</code>.
     */
    public final TableField<VDataquierRecord, JSONB> HARD_LIMITS = createField(DSL.name("hard_limits"), SQLDataType.JSONB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.soft_limits</code>.
     */
    public final TableField<VDataquierRecord, JSONB> SOFT_LIMITS = createField(DSL.name("soft_limits"), SQLDataType.JSONB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.jump_list</code>.
     */
    public final TableField<VDataquierRecord, JSONB> JUMP_LIST = createField(DSL.name("jump_list"), SQLDataType.JSONB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.report_name</code>.
     */
    public final TableField<VDataquierRecord, String> REPORT_NAME = createField(DSL.name("report_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.create_report</code>.
     */
    public final TableField<VDataquierRecord, String> CREATE_REPORT = createField(DSL.name("create_report"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.stata_jumps</code>.
     */
    public final TableField<VDataquierRecord, String> STATA_JUMPS = createField(DSL.name("stata_jumps"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.jump_list_en</code>.
     */
    public final TableField<VDataquierRecord, String> JUMP_LIST_EN = createField(DSL.name("jump_list_en"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.jump_list_de</code>.
     */
    public final TableField<VDataquierRecord, String> JUMP_LIST_DE = createField(DSL.name("jump_list_de"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.variable_role</code>.
     */
    public final TableField<VDataquierRecord, String> VARIABLE_ROLE = createField(DSL.name("variable_role"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.order_nr</code>.
     */
    public final TableField<VDataquierRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dataquier.parent_name</code>.
     */
    public final TableField<VDataquierRecord, String> PARENT_NAME = createField(DSL.name("parent_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.table_name</code>.
     */
    public final TableField<VDataquierRecord, String> TABLE_NAME = createField(DSL.name("table_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.qs_missing_list</code>.
     */
    public final TableField<VDataquierRecord, String> QS_MISSING_LIST = createField(DSL.name("qs_missing_list"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.qs_missing_list_de</code>.
     */
    public final TableField<VDataquierRecord, String> QS_MISSING_LIST_DE = createField(DSL.name("qs_missing_list_de"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.qs_jump_list_en</code>.
     */
    public final TableField<VDataquierRecord, String> QS_JUMP_LIST_EN = createField(DSL.name("qs_jump_list_en"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dataquier.qs_jump_list_de</code>.
     */
    public final TableField<VDataquierRecord, String> QS_JUMP_LIST_DE = createField(DSL.name("qs_jump_list_de"), SQLDataType.CLOB, this, "");

    private VDataquier(Name alias, Table<VDataquierRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDataquier(Name alias, Table<VDataquierRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dataquier" as  WITH vl(fk_var_valuelist, codes, isocode) AS (
                SELECT val.fk_value_valuelist,
                   string_agg(((val.varvalue || '='::text) || valt.value), '|'::text ORDER BY val.value_order) AS string_agg,
                   valt.isocode
                  FROM ((common_dd.t_core_value val
                    LEFT JOIN common_dd.t_core_valueparam valp ON ((valp.fk_valueparam_value = val.pk_core_value)))
                    LEFT JOIN common_dd.t_core_translation valt ON (((valt.fk_trans_key = valp.param_key) AND (valt.category = 'crf'::common_dd.enum_trans_category))))
                 GROUP BY val.fk_value_valuelist, valt.isocode
               ), ml(missinglist, codes, isocode, stata_codes) AS (
                SELECT mv.fk_missinglist,
                   string_agg(((c.num_missingcode || '='::text) || t.value), '|'::text) AS string_agg,
                   t.isocode,
                   string_agg((c.num_missingcode)::text, ' '::text) AS string_agg
                  FROM (((((common_dd.t_core_missingvalue mv
                    LEFT JOIN common_dd.t_core_missingmaster mm ON ((mm.pk = mv.fk_missingmaster)))
                    LEFT JOIN common_dd.t_dm_missingvalue dmv ON ((dmv.fk_core_missingvalue = mv.pk)))
                    LEFT JOIN common_dd.t_dm_missingcode c ON ((c.pk = dmv.fk_missingcode)))
                    LEFT JOIN common_dd.t_core_translation t ON (((t.fk_trans_key = mm.fk_lang) AND (t.category = 'crf'::common_dd.enum_trans_category))))
                    LEFT JOIN common_dd.t_core_missingclass mc ON ((mc.pk = mv.fk_missingclass)))
                 WHERE (mc.name = 'missing'::text)
                 GROUP BY mv.fk_missinglist, t.isocode
               ), jl(jumplist, codes, isocode, stata_codes) AS (
                SELECT mv.fk_missinglist,
                   string_agg(((c.num_missingcode || '='::text) || t.value), '|'::text) AS string_agg,
                   t.isocode,
                   string_agg((c.num_missingcode)::text, ' '::text) AS string_agg
                  FROM (((((common_dd.t_core_missingvalue mv
                    LEFT JOIN common_dd.t_core_missingmaster mm ON ((mm.pk = mv.fk_missingmaster)))
                    LEFT JOIN common_dd.t_dm_missingvalue dmv ON ((dmv.fk_core_missingvalue = mv.pk)))
                    LEFT JOIN common_dd.t_dm_missingcode c ON ((c.pk = dmv.fk_missingcode)))
                    LEFT JOIN common_dd.t_core_translation t ON (((t.fk_trans_key = mm.fk_lang) AND (t.category = 'crf'::common_dd.enum_trans_category))))
                    LEFT JOIN common_dd.t_core_missingclass mc ON ((mc.pk = mv.fk_missingclass)))
                 WHERE (mc.name = 'jump'::text)
                 GROUP BY mv.fk_missinglist, t.isocode
               ), qml(missinglist, codes, isocode, stata_codes) AS (
                SELECT mv.fk_missinglist,
                   string_agg(((c.num_missingcode || '='::text) || t.value), '|'::text) AS string_agg,
                   t.isocode,
                   string_agg((c.num_missingcode)::text, ' '::text) AS string_agg
                  FROM (((((common_dd.t_core_missingvalue mv
                    LEFT JOIN common_dd.t_core_missingmaster mm ON ((mm.pk = mv.fk_missingmaster)))
                    LEFT JOIN common_dd.t_dm_missingvalue dmv ON ((dmv.fk_core_missingvalue = mv.pk)))
                    LEFT JOIN common_dd.t_dm_missingcode c ON ((c.pk = dmv.fk_missingcode)))
                    LEFT JOIN common_dd.t_core_translation t ON (((t.fk_trans_key = mm.fk_lang) AND (t.category = 'crf'::common_dd.enum_trans_category))))
                    LEFT JOIN common_dd.t_core_missingclass mc ON ((mc.pk = mv.fk_missingclass_qs)))
                 WHERE (mc.name = 'missing'::text)
                 GROUP BY mv.fk_missinglist, t.isocode
               ), qjl(jumplist, codes, isocode, stata_codes) AS (
                SELECT mv.fk_missinglist,
                   string_agg(((c.num_missingcode || '='::text) || t.value), '|'::text) AS string_agg,
                   t.isocode,
                   string_agg((c.num_missingcode)::text, ' '::text) AS string_agg
                  FROM (((((common_dd.t_core_missingvalue mv
                    LEFT JOIN common_dd.t_core_missingmaster mm ON ((mm.pk = mv.fk_missingmaster)))
                    LEFT JOIN common_dd.t_dm_missingvalue dmv ON ((dmv.fk_core_missingvalue = mv.pk)))
                    LEFT JOIN common_dd.t_dm_missingcode c ON ((c.pk = dmv.fk_missingcode)))
                    LEFT JOIN common_dd.t_core_translation t ON (((t.fk_trans_key = mm.fk_lang) AND (t.category = 'crf'::common_dd.enum_trans_category))))
                    LEFT JOIN common_dd.t_core_missingclass mc ON ((mc.pk = mv.fk_missingclass_qs)))
                 WHERE (mc.name = 'jump'::text)
                 GROUP BY mv.fk_missinglist, t.isocode
               ), logiccond(fk_element, logictype_descr, fk_orgrp, cond) AS (
                SELECT l.fk_variable,
                   ty.logictype_descr,
                   l.fk_orgrp,
                   string_agg(((h1.short_name || co.logiccond_comparator) ||
                       CASE co.compare_variables
                           WHEN 1 THEN h2.short_name
                           ELSE (co.logiccond_value)::text
                       END), '&'::text) AS string_agg
                  FROM (((((common_dd.t_core_logic l
                    LEFT JOIN common_dd.t_core_logictype ty ON ((ty.logictype = l.fk_logictype)))
                    LEFT JOIN common_dd.t_core_logicandgrp a_1 ON ((a_1.fk_orgrp = l.fk_orgrp)))
                    LEFT JOIN common_dd.t_core_logiccond co ON ((co.fk_andgrp = a_1.andgrp)))
                    LEFT JOIN common_dd.t_core_element_hierarchy h1 ON ((h1.key_element = co.fk_variable)))
                    LEFT JOIN common_dd.t_core_element_hierarchy h2 ON ((h2.key_element = co.fk_variable2)))
                 GROUP BY l.fk_variable, ty.logictype_descr, l.fk_orgrp, co.fk_andgrp
               ), logic(fk_element, dependency, softlimit, hardlimit) AS (
                SELECT lc1.fk_element,
                   string_agg(DISTINCT lc1.cond, '|'::text) AS string_agg,
                   string_agg(DISTINCT lc2.cond, '|'::text) AS string_agg,
                   string_agg(DISTINCT lc3.cond, '|'::text) AS string_agg
                  FROM ((logiccond lc1
                    LEFT JOIN logiccond lc2 ON (((lc2.fk_element = lc1.fk_element) AND (lc2.logictype_descr = 'logictype.validation.warn'::text))))
                    LEFT JOIN logiccond lc3 ON (((lc3.fk_element = lc1.fk_element) AND (lc3.logictype_descr = 'logictype.validation.error'::text))))
                 WHERE (lc1.logictype_descr = 'logictype.dependency'::text)
                 GROUP BY lc1.fk_element, lc1.logictype_descr
               ), attr(fk_element, hard_limits, soft_limits, jump_list) AS (
                SELECT v_1.key_variable,
                   h.value,
                   s.value,
                   j.value
                  FROM (((common_dd.t_core_variable v_1
                    LEFT JOIN common_dd.t_core_variableattr h ON (((h.fk_variable = v_1.key_variable) AND (h.fk_variableattrtype IN ( SELECT t_core_variableattrtype.pk
                          FROM common_dd.t_core_variableattrtype
                         WHERE (t_core_variableattrtype.name = 'hard_limits'::text))))))
                    LEFT JOIN common_dd.t_core_variableattr s ON (((s.fk_variable = v_1.key_variable) AND (s.fk_variableattrtype IN ( SELECT t_core_variableattrtype.pk
                          FROM common_dd.t_core_variableattrtype
                         WHERE (t_core_variableattrtype.name = 'soft_limits'::text))))))
                    LEFT JOIN common_dd.t_core_variableattr j ON (((j.fk_variable = v_1.key_variable) AND (j.fk_variableattrtype IN ( SELECT t_core_variableattrtype.pk
                          FROM common_dd.t_core_variableattrtype
                         WHERE (t_core_variableattrtype.name = 'jump_list'::text))))))
               )
        SELECT e.unique_name AS var_names,
           t1.value AS label,
           t2.value AS long_label,
           t3.value AS label_de,
           t4.value AS long_label_de,
           v.data_type,
           vl_en.codes AS value_labels,
           vl_de.codes AS value_labels_de,
           ml_en.codes AS missing_list,
           ml_de.codes AS missing_list_de,
           pe1.unique_name AS key_observer,
           pe2.unique_name AS key_datetime,
           pe3.unique_name AS key_device,
           seg.name AS key_study_segment,
           e.order_nr AS variable_order,
           e.short_name,
           qml_en.stata_codes AS stata_missing,
           lo.dependency AS stata_dependency,
           lo.hardlimit AS stata_hard_limit,
           lo.softlimit AS stata_soft_limit,
           pe1.short_name AS stata_key_observer,
           pe2.short_name AS stata_key_datetime,
           pe3.short_name AS stata_key_device,
           a.hard_limits,
           a.soft_limits,
           a.jump_list,
           seg.report_name,
           seg.create_report,
           qjl_en.stata_codes AS stata_jumps,
           jl_en.codes AS jump_list_en,
           jl_de.codes AS jump_list_de,
           seg.variable_role,
           e.order_nr,
           COALESCE(p.unique_name, p.dn) AS parent_name,
           ('T_'::text || upper(COALESCE(tabledef.table_short_name, 'unspecified'::text))) AS table_name,
           qml_en.codes AS qs_missing_list,
           qml_de.codes AS qs_missing_list_de,
           qjl_en.codes AS qs_jump_list_en,
           qjl_de.codes AS qs_jump_list_de
          FROM (((((((((((((((((((((((((((((common_dd.t_core_variable v
            LEFT JOIN attr a ON ((a.fk_element = v.key_variable)))
            LEFT JOIN common_dd.t_core_variable_segment seg ON ((seg.fk_element = v.key_variable)))
            LEFT JOIN common_dd.t_core_element_hierarchy e ON ((e.key_element = v.key_variable)))
            LEFT JOIN common_dd.t_core_element_hierarchy p ON ((p.key_element = e.key_parent_element)))
            LEFT JOIN common_dd.t_core_translation t1 ON (((t1.fk_trans_key = e.hier_lang) AND (t1.isocode = 'en'::common_dd.enum_isocode) AND (t1.category = 'crf'::common_dd.enum_trans_category))))
            LEFT JOIN common_dd.t_core_translation t2 ON (((t2.fk_trans_key = e.hier_lang) AND (t2.isocode = 'en'::common_dd.enum_isocode) AND (t2.category = 'long'::common_dd.enum_trans_category))))
            LEFT JOIN common_dd.t_core_translation t3 ON (((t3.fk_trans_key = e.hier_lang) AND (t3.isocode = 'de_DE'::common_dd.enum_isocode) AND (t3.category = 'crf'::common_dd.enum_trans_category))))
            LEFT JOIN common_dd.t_core_translation t4 ON (((t4.fk_trans_key = e.hier_lang) AND (t4.isocode = 'de_DE'::common_dd.enum_isocode) AND (t4.category = 'long'::common_dd.enum_trans_category))))
            LEFT JOIN common_dd.t_core_processtype pt1 ON ((pt1.name = 'observer'::text)))
            LEFT JOIN common_dd.t_core_processvar pv1 ON (((pv1.fk_element = e.key_element) AND (pv1.fk_processtype = pt1.pk))))
            LEFT JOIN common_dd.t_core_element_hierarchy pe1 ON ((pe1.key_element = pv1.fk_referenced_element)))
            LEFT JOIN common_dd.t_core_processtype pt2 ON ((pt2.name = 'timevar'::text)))
            LEFT JOIN common_dd.t_core_processvar pv2 ON (((pv2.fk_element = e.key_element) AND (pv2.fk_processtype = pt2.pk))))
            LEFT JOIN common_dd.t_core_element_hierarchy pe2 ON ((pe2.key_element = pv2.fk_referenced_element)))
            LEFT JOIN common_dd.t_core_processtype pt3 ON ((pt3.name = 'device'::text)))
            LEFT JOIN common_dd.t_core_processvar pv3 ON (((pv3.fk_element = e.key_element) AND (pv3.fk_processtype = pt3.pk))))
            LEFT JOIN common_dd.t_core_element_hierarchy pe3 ON ((pe3.key_element = pv3.fk_referenced_element)))
            LEFT JOIN vl vl_en ON (((vl_en.fk_var_valuelist = v.fk_var_valuelist) AND (vl_en.isocode = 'en'::common_dd.enum_isocode))))
            LEFT JOIN vl vl_de ON (((vl_de.fk_var_valuelist = v.fk_var_valuelist) AND (vl_de.isocode = 'de_DE'::common_dd.enum_isocode))))
            LEFT JOIN ml ml_en ON (((ml_en.missinglist = v.fk_missinglist) AND (ml_en.isocode = 'en'::common_dd.enum_isocode))))
            LEFT JOIN ml ml_de ON (((ml_de.missinglist = v.fk_missinglist) AND (ml_de.isocode = 'de_DE'::common_dd.enum_isocode))))
            LEFT JOIN jl jl_en ON (((jl_en.jumplist = v.fk_missinglist) AND (jl_en.isocode = 'en'::common_dd.enum_isocode))))
            LEFT JOIN jl jl_de ON (((jl_de.jumplist = v.fk_missinglist) AND (jl_de.isocode = 'de_DE'::common_dd.enum_isocode))))
            LEFT JOIN qml qml_en ON (((qml_en.missinglist = v.fk_missinglist) AND (qml_en.isocode = 'en'::common_dd.enum_isocode))))
            LEFT JOIN qml qml_de ON (((qml_de.missinglist = v.fk_missinglist) AND (qml_de.isocode = 'de_DE'::common_dd.enum_isocode))))
            LEFT JOIN qjl qjl_en ON (((qjl_en.jumplist = v.fk_missinglist) AND (qjl_en.isocode = 'en'::common_dd.enum_isocode))))
            LEFT JOIN qjl qjl_de ON (((qjl_de.jumplist = v.fk_missinglist) AND (qjl_de.isocode = 'de_DE'::common_dd.enum_isocode))))
            LEFT JOIN logic lo ON ((lo.fk_element = v.key_variable)))
            LEFT JOIN common_dd.v_dm_tablevar tabledef ON ((tabledef.variable_key_element = v.key_variable)))
         WHERE ((e.unique_name IS NOT NULL) AND (e.stage = 3) AND (e.is_public <> 0));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier</code> table reference
     */
    public VDataquier(String alias) {
        this(DSL.name(alias), V_DATAQUIER);
    }

    /**
     * Create an aliased <code>common_dd.v_dataquier</code> table reference
     */
    public VDataquier(Name alias) {
        this(alias, V_DATAQUIER);
    }

    /**
     * Create a <code>common_dd.v_dataquier</code> table reference
     */
    public VDataquier() {
        this(DSL.name("v_dataquier"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDataquier as(String alias) {
        return new VDataquier(DSL.name(alias), this);
    }

    @Override
    public VDataquier as(Name alias) {
        return new VDataquier(alias, this);
    }

    @Override
    public VDataquier as(Table<?> alias) {
        return new VDataquier(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquier rename(String name) {
        return new VDataquier(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquier rename(Name name) {
        return new VDataquier(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDataquier rename(Table<?> name) {
        return new VDataquier(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier where(Condition condition) {
        return new VDataquier(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquier where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquier where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquier where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDataquier where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDataquier whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
